local isLocalLoggingEnabled = false;

if not SurvivorSpeechTable then
  SurvivorSpeechTable = {};
end

--- gets a random speech text of a dialogue list
---@param key string key of the speech
---@return string a survivor speech
function Get_SS_DialogueSpeech(key)
  CreateLogLine("SuperSurvivorDialogue", isLocalLoggingEnabled, "Get_SS_DialogueSpeech() called");
  if (not SurvivorSpeechTable[key]) then
    return "?"
  end

  local result = ZombRand(1, #SurvivorSpeechTable[key]);
  return tostring(SurvivorSpeechTable[key][result]);
end

-- WIP - Cows: WifeSpeech is CURRENTLY NOT USED
WifeSpeech = {
  Get_SS_Dialogue("WifeSpeech1"),
  Get_SS_Dialogue("WifeSpeech2"),
  Get_SS_Dialogue("WifeSpeech3"),
  Get_SS_Dialogue("WifeSpeech4"),
  Get_SS_Dialogue("WifeSpeech5"),
}
SurvivorSpeechTable["HelloThere"] = {
  Get_SS_Dialogue("HiThere"),
  Get_SS_Dialogue("HelloThere"),
  Get_SS_Dialogue("HelloWord1"),
  Get_SS_Dialogue("HelloWord2"),
  Get_SS_Dialogue("HelloWord3"),
  Get_SS_Dialogue("HelloWord4"),
  Get_SS_Dialogue("HelloWord5"),
  Get_SS_Dialogue("HelloWord6"),
  Get_SS_Dialogue("HelloWord7"),
  Get_SS_Dialogue("HelloWord8"),
  Get_SS_Dialogue("HelloWord9"),
  Get_SS_Dialogue("HelloWord10"),
  Get_SS_Dialogue("HelloWord11"),
  Get_SS_Dialogue("HelloWord12"),
  Get_SS_Dialogue("HelloWord13"),
  Get_SS_Dialogue("HelloWord14"),
};

SurvivorSpeechTable["OutOfAmmo"] = {
  Get_SS_Dialogue("OutOfAmmo1"),
  Get_SS_Dialogue("OutOfAmmo2"),
  Get_SS_Dialogue("OutOfAmmo3"),
  Get_SS_Dialogue("OutOfAmmo4"),
};

SurvivorSpeechTable["HowDareYou"] = {
  Get_SS_Dialogue("HowDareYou1"),
};
SurvivorSpeechTable["WifeIntro"] = {
  Get_SS_Dialogue("WifeIntro1"),
};

SurvivorSpeechTable["IDontKnowHowDoctor"] = {
  Get_SS_Dialogue("IDontKnowHowDoctor1"),
};

SurvivorSpeechTable["IfYouThinkSo"] = {
  Get_SS_Dialogue("IfYouThinkSo1"),
  Get_SS_Dialogue("IfYouThinkSo2"),
};

SurvivorSpeechTable["SawHimThere"] = {
  Get_SS_Dialogue("SawHimThere1"),
  Get_SS_Dialogue("SawHimThere2"),
  Get_SS_Dialogue("SawHimThere3"),
  Get_SS_Dialogue("SawHimThere4"),
};

SurvivorSpeechTable["GonnaGetYou"] = {
  Get_SS_Dialogue("GonnaGetYou1"),
  Get_SS_Dialogue("GonnaGetYou2"),
  Get_SS_Dialogue("GonnaGetYou3"),
  Get_SS_Dialogue("GonnaGetYou4"),
  Get_SS_Dialogue("GonnaGetYou5"),
};


SurvivorSpeechTable["SeenPlayerIll"] = {
  Get_SS_Dialogue("SeenPlayerIll1"),
  Get_SS_Dialogue("SeenPlayerIll2"),
  Get_SS_Dialogue("SeenPlayerIll3"),
  Get_SS_Dialogue("SeenPlayerIll4"),
  Get_SS_Dialogue("SeenPlayerIll5"),
  Get_SS_Dialogue("SeenPlayerIll6"),
  Get_SS_Dialogue("SeenPlayerIll7"),
  Get_SS_Dialogue("SeenPlayerIll8"),
};

SurvivorSpeechTable["SeenPlayerBit"] = {
  Get_SS_Dialogue("SeenPlayerBit1"),
  Get_SS_Dialogue("SeenPlayerBit2"),
  Get_SS_Dialogue("SeenPlayerBit3"),
  Get_SS_Dialogue("SeenPlayerBit4"),
  Get_SS_Dialogue("SeenPlayerBit5"),
  Get_SS_Dialogue("SeenPlayerBit6"),
  Get_SS_Dialogue("SeenPlayerBit7"),
  Get_SS_Dialogue("SeenPlayerBit8"),
  Get_SS_Dialogue("SeenPlayerBit9"),
  Get_SS_Dialogue("SeenPlayerBit10"),
  Get_SS_Dialogue("SeenPlayerBit11"),
  Get_SS_Dialogue("SeenPlayerBit12"),
  Get_SS_Dialogue("SeenPlayerBit13"),
};

SurvivorSpeechTable["Crying"] = {
  Get_SS_Dialogue("Crying1"),
  Get_SS_Dialogue("Crying2"),
  Get_SS_Dialogue("Crying3"),
  Get_SS_Dialogue("Crying4"),
  Get_SS_Dialogue("Crying5"),
  Get_SS_Dialogue("Crying6"),
  Get_SS_Dialogue("Crying7"),
  Get_SS_Dialogue("Crying8"),
  Get_SS_Dialogue("Crying9"),
  Get_SS_Dialogue("Crying10"),
  Get_SS_Dialogue("Crying11"),
  Get_SS_Dialogue("Crying12"),
  Get_SS_Dialogue("Crying13"),
  Get_SS_Dialogue("Crying14"),
  Get_SS_Dialogue("Crying15"),
  Get_SS_Dialogue("Crying16"),
};

SurvivorSpeechTable["Tired"] = {
  Get_SS_Dialogue("Tired1"),
  Get_SS_Dialogue("Tired2"),
  Get_SS_Dialogue("Tired3"),
  Get_SS_Dialogue("Tired4"),
  Get_SS_Dialogue("Tired5"),
  Get_SS_Dialogue("Tired6"),
  Get_SS_Dialogue("Tired7"),
  Get_SS_Dialogue("Tired8"),
  Get_SS_Dialogue("Tired9"),
  Get_SS_Dialogue("Tired10"),
  Get_SS_Dialogue("Tired11"),
};


SurvivorSpeechTable["VTired"] = {
  Get_SS_Dialogue("VTired1"),
  Get_SS_Dialogue("VTired2"),
  Get_SS_Dialogue("VTired3"),
  Get_SS_Dialogue("VTired4"),
  Get_SS_Dialogue("VTired5"),
  Get_SS_Dialogue("VTired6"),
};



SurvivorSpeechTable["STired"] = {
  Get_SS_Dialogue("STired1"),
  Get_SS_Dialogue("STired2"),
  Get_SS_Dialogue("STired3"),
  Get_SS_Dialogue("STired4"),
  Get_SS_Dialogue("STired5"),
  Get_SS_Dialogue("STired6"),
  Get_SS_Dialogue("STired7"),
};


SurvivorSpeechTable["Thirsty"] = {
  Get_SS_Dialogue("Thirsty1"),
  Get_SS_Dialogue("Thirsty2"),
  Get_SS_Dialogue("Thirsty3"),
  Get_SS_Dialogue("Thirsty4"),
  Get_SS_Dialogue("Thirsty5"),
  Get_SS_Dialogue("Thirsty6"),
  Get_SS_Dialogue("Thirsty7"),
  Get_SS_Dialogue("Thirsty8"),
  Get_SS_Dialogue("Thirsty9"),
  Get_SS_Dialogue("Thirsty10"),
};


SurvivorSpeechTable["VThirsty"] = {
  Get_SS_Dialogue("VThirsty1"),
  Get_SS_Dialogue("VThirsty2"),
  Get_SS_Dialogue("VThirsty3"),
  Get_SS_Dialogue("VThirsty4"),
  Get_SS_Dialogue("VThirsty5"),
  Get_SS_Dialogue("VThirsty6"),
  Get_SS_Dialogue("VThirsty7"),
  Get_SS_Dialogue("VThirsty8"),
  Get_SS_Dialogue("VThirsty9"),
  Get_SS_Dialogue("VThirsty10"),
};


SurvivorSpeechTable["SThirsty"] = {
  Get_SS_Dialogue("SThirsty1"),
  Get_SS_Dialogue("SThirsty2"),
  Get_SS_Dialogue("SThirsty3"),
  Get_SS_Dialogue("SThirsty4"),
  Get_SS_Dialogue("SThirsty5"),
  Get_SS_Dialogue("SThirsty6"),
  Get_SS_Dialogue("SThirsty7"),
  Get_SS_Dialogue("SThirsty8"),
  Get_SS_Dialogue("SThirsty9"),
  Get_SS_Dialogue("SThirsty10"),
};


SurvivorSpeechTable["Respond"] = {
  Get_SS_Dialogue("Respond1"),
  Get_SS_Dialogue("Respond2"),
  Get_SS_Dialogue("Respond3"),
  Get_SS_Dialogue("Respond4"),
  Get_SS_Dialogue("Respond5"),
  Get_SS_Dialogue("Respond6"),
  Get_SS_Dialogue("Respond7"),
  Get_SS_Dialogue("Respond8"),
  Get_SS_Dialogue("Respond9"),
  Get_SS_Dialogue("Respond10"),
  Get_SS_Dialogue("Respond11"),
  Get_SS_Dialogue("Respond12"),
  Get_SS_Dialogue("Respond13"),
  Get_SS_Dialogue("Respond14"),
  Get_SS_Dialogue("Respond15"),
  Get_SS_Dialogue("Respond16"),
  Get_SS_Dialogue("Respond17"),
  Get_SS_Dialogue("Respond18"),
  Get_SS_Dialogue("Respond19"),
  Get_SS_Dialogue("Respond20"),
};

SurvivorSpeechTable["Sick"] = {
  Get_SS_Dialogue("Sick1"),
  Get_SS_Dialogue("Sick2"),
};

SurvivorSpeechTable["VSick"] = {
  Get_SS_Dialogue("VSick1"),
  Get_SS_Dialogue("VSick2"),
};

SurvivorSpeechTable["SSick"] = {
  Get_SS_Dialogue("SSick1"),
  Get_SS_Dialogue("SSick2"),
};

SurvivorSpeechTable["Hungry"] = {
  Get_SS_Dialogue("Hungry1"),
  Get_SS_Dialogue("Hungry2"),
  Get_SS_Dialogue("Hungry3"),
  Get_SS_Dialogue("Hungry4"),
  Get_SS_Dialogue("Hungry5"),
  Get_SS_Dialogue("Hungry6"),
  Get_SS_Dialogue("Hungry7"),
  Get_SS_Dialogue("Hungry8"),
  Get_SS_Dialogue("Hungry9"),
  Get_SS_Dialogue("Hungry10"),
};

SurvivorSpeechTable["VHungry"] = {
  Get_SS_Dialogue("VHungry1"),
  Get_SS_Dialogue("VHungry2"),
  Get_SS_Dialogue("VHungry3"),
  Get_SS_Dialogue("VHungry4"),
  Get_SS_Dialogue("VHungry5"),
  Get_SS_Dialogue("VHungry6"),
  Get_SS_Dialogue("VHungry7"),
  Get_SS_Dialogue("VHungry8"),
  Get_SS_Dialogue("VHungry9"),
  Get_SS_Dialogue("VHungry10"),
};


SurvivorSpeechTable["Starving"] = {
  Get_SS_Dialogue("Starving1"),
  Get_SS_Dialogue("Starving2"),
  Get_SS_Dialogue("Starving3"),
  Get_SS_Dialogue("Starving4"),
  Get_SS_Dialogue("Starving5"),
  Get_SS_Dialogue("Starving6"),
  Get_SS_Dialogue("Starving7"),
  Get_SS_Dialogue("Starving8"),
  Get_SS_Dialogue("Starving9"),
  Get_SS_Dialogue("Starving10"),
};

SurvivorSpeechTable["Roger"] = {
  Get_SS_Dialogue("Roger1"),
  Get_SS_Dialogue("Roger2"),
  Get_SS_Dialogue("Roger3"),
  Get_SS_Dialogue("Roger4"),
  Get_SS_Dialogue("Roger5"),
  Get_SS_Dialogue("Roger6"),
  Get_SS_Dialogue("Roger7"),
  Get_SS_Dialogue("Roger8"),
  Get_SS_Dialogue("Roger9"),
  Get_SS_Dialogue("Roger10"),
  Get_SS_Dialogue("Roger11"),
  Get_SS_Dialogue("Roger12"),
  Get_SS_Dialogue("Roger13"),
  Get_SS_Dialogue("Roger14"),
  Get_SS_Dialogue("Roger15"),
  Get_SS_Dialogue("Roger16"),
  Get_SS_Dialogue("Roger17"),
  Get_SS_Dialogue("Roger18"),
  Get_SS_Dialogue("Roger19"),
  Get_SS_Dialogue("Roger20"),
  Get_SS_Dialogue("Roger21"),
  Get_SS_Dialogue("Roger22"),
  Get_SS_Dialogue("Roger23"),
  Get_SS_Dialogue("Roger24"),
  Get_SS_Dialogue("Roger25"),
  Get_SS_Dialogue("Roger26"),
  Get_SS_Dialogue("Roger27"),
  Get_SS_Dialogue("Roger28"),
  Get_SS_Dialogue("Roger29"),
  Get_SS_Dialogue("Roger30"),
};

SurvivorSpeechTable["No"] = {
  Get_SS_Dialogue("No1"),
  Get_SS_Dialogue("No2"),
  Get_SS_Dialogue("No3"),
  Get_SS_Dialogue("No4"),
  Get_SS_Dialogue("No5"),
  Get_SS_Dialogue("No6"),
  Get_SS_Dialogue("No7"),
  Get_SS_Dialogue("No8"),
  Get_SS_Dialogue("No9"),
  Get_SS_Dialogue("No10"),
  Get_SS_Dialogue("No11"),
  Get_SS_Dialogue("No12"),
};

SurvivorSpeechTable["Thanks"] = {
  Get_SS_Dialogue("Thanks1"),
  Get_SS_Dialogue("Thanks2"),
  Get_SS_Dialogue("Thanks3"),
  Get_SS_Dialogue("Thanks4"),
  Get_SS_Dialogue("Thanks5"),
  Get_SS_Dialogue("Thanks6"),
  Get_SS_Dialogue("Thanks7"),
  Get_SS_Dialogue("Thanks8"),
};

SurvivorSpeechTable["HitByPlayer"] = {
  Get_SS_Dialogue("HitByPlayer1"),
  Get_SS_Dialogue("HitByPlayer2"),
  Get_SS_Dialogue("HitByPlayer3"),
  Get_SS_Dialogue("HitByPlayer4"),
  Get_SS_Dialogue("HitByPlayer5"),
  Get_SS_Dialogue("HitByPlayer6"),
  Get_SS_Dialogue("HitByPlayer7"),
  Get_SS_Dialogue("HitByPlayer8"),
  Get_SS_Dialogue("HitByPlayer9"),
  Get_SS_Dialogue("HitByPlayer10"),
  Get_SS_Dialogue("HitByPlayer11"),
  Get_SS_Dialogue("HitByPlayer12"),
  Get_SS_Dialogue("HitByPlayer13"),
  Get_SS_Dialogue("HitByPlayer14"),
  Get_SS_Dialogue("HitByPlayer15"),
  Get_SS_Dialogue("HitByPlayer16"),
  Get_SS_Dialogue("HitByPlayer17"),
  Get_SS_Dialogue("HitByPlayer18"),
  Get_SS_Dialogue("HitByPlayer19"),
  Get_SS_Dialogue("HitByPlayer20"),
  Get_SS_Dialogue("HitByPlayer21"),
  Get_SS_Dialogue("HitByPlayer22"),
  Get_SS_Dialogue("HitByPlayer23"),
  Get_SS_Dialogue("HitByPlayer24"),
  Get_SS_Dialogue("HitByPlayer25"),
  Get_SS_Dialogue("HitByPlayer26"),
  Get_SS_Dialogue("HitByPlayer27"),
  Get_SS_Dialogue("HitByPlayer28"),
  Get_SS_Dialogue("HitByPlayer29"),
};


SurvivorSpeechTable["SeenFirstZombie"] = {
  Get_SS_Dialogue("SeenFirstZombie1"),
  Get_SS_Dialogue("SeenFirstZombie2"),
  Get_SS_Dialogue("SeenFirstZombie3"),
  Get_SS_Dialogue("SeenFirstZombie4"),
  Get_SS_Dialogue("SeenFirstZombie5"),
  Get_SS_Dialogue("SeenFirstZombie6"),
  Get_SS_Dialogue("SeenFirstZombie7"),
  Get_SS_Dialogue("SeenFirstZombie8"),
  Get_SS_Dialogue("SeenFirstZombie9"),
  Get_SS_Dialogue("SeenFirstZombie10"),
  Get_SS_Dialogue("SeenFirstZombie11"),
  Get_SS_Dialogue("SeenFirstZombie12"),
  Get_SS_Dialogue("SeenFirstZombie13"),
  Get_SS_Dialogue("SeenFirstZombie14"),
  Get_SS_Dialogue("SeenFirstZombie15"),
  Get_SS_Dialogue("SeenFirstZombie16"),
  Get_SS_Dialogue("SeenFirstZombie17"),
  Get_SS_Dialogue("SeenFirstZombie18"),
};


SurvivorSpeechTable["IdleChatter"] = {
  Get_SS_Dialogue("IdleChatter1"),
  Get_SS_Dialogue("IdleChatter2"),
  Get_SS_Dialogue("IdleChatter3"),
  Get_SS_Dialogue("IdleChatter4"),
  Get_SS_Dialogue("IdleChatter5"),
  Get_SS_Dialogue("IdleChatter6"),
  Get_SS_Dialogue("IdleChatter7"),
  Get_SS_Dialogue("IdleChatter8"),
  Get_SS_Dialogue("IdleChatter9"),
  Get_SS_Dialogue("IdleChatter10"),
  Get_SS_Dialogue("IdleChatter11"),
  Get_SS_Dialogue("IdleChatter12"),
  Get_SS_Dialogue("IdleChatter13"),
  Get_SS_Dialogue("IdleChatter14"),
  Get_SS_Dialogue("IdleChatter15"),
  Get_SS_Dialogue("IdleChatter16"),
  Get_SS_Dialogue("IdleChatter17"),
  Get_SS_Dialogue("IdleChatter18"),
  Get_SS_Dialogue("IdleChatter19"),
  Get_SS_Dialogue("IdleChatter20"),
  Get_SS_Dialogue("IdleChatter21"),
  Get_SS_Dialogue("IdleChatter22"),
  Get_SS_Dialogue("IdleChatter23"),
  Get_SS_Dialogue("IdleChatter24"),
  Get_SS_Dialogue("IdleChatter25"),
  Get_SS_Dialogue("IdleChatter26"),
  Get_SS_Dialogue("IdleChatter27"),
  Get_SS_Dialogue("IdleChatter28"),
  Get_SS_Dialogue("IdleChatter29"),
  Get_SS_Dialogue("IdleChatter30"),
  Get_SS_Dialogue("IdleChatter31"),
  Get_SS_Dialogue("IdleChatter32"),
  Get_SS_Dialogue("IdleChatter33"),
  Get_SS_Dialogue("IdleChatter34"),
  Get_SS_Dialogue("IdleChatter35"),
  Get_SS_Dialogue("IdleChatter36"),
  Get_SS_Dialogue("IdleChatter37"),
  Get_SS_Dialogue("IdleChatter38"),
  Get_SS_Dialogue("IdleChatter39"),
  Get_SS_Dialogue("IdleChatter40"),
  Get_SS_Dialogue("IdleChatter41"),
  Get_SS_Dialogue("IdleChatter42"),
  Get_SS_Dialogue("IdleChatter43"),
  Get_SS_Dialogue("IdleChatter44"),
  Get_SS_Dialogue("IdleChatter45"),
  Get_SS_Dialogue("IdleChatter46"),
  Get_SS_Dialogue("IdleChatter47"),
  Get_SS_Dialogue("IdleChatter48"),
  Get_SS_Dialogue("IdleChatter49"),
  Get_SS_Dialogue("IdleChatter50"),
  Get_SS_Dialogue("IdleChatter51"),
  Get_SS_Dialogue("IdleChatter52"),
  Get_SS_Dialogue("IdleChatter53"),
  Get_SS_Dialogue("IdleChatter54"),
  Get_SS_Dialogue("IdleChatter55"),
  Get_SS_Dialogue("IdleChatter56"),
  Get_SS_Dialogue("IdleChatter57"),
  Get_SS_Dialogue("IdleChatter58"),
  Get_SS_Dialogue("IdleChatter59"),
  Get_SS_Dialogue("IdleChatter60"),
  Get_SS_Dialogue("IdleChatter61"),
  Get_SS_Dialogue("IdleChatter62"),
  Get_SS_Dialogue("IdleChatter63"),
  Get_SS_Dialogue("IdleChatter64"),
  Get_SS_Dialogue("IdleChatter65"),
  Get_SS_Dialogue("IdleChatter66"),
  Get_SS_Dialogue("IdleChatter67"),
  Get_SS_Dialogue("IdleChatter68"),
  Get_SS_Dialogue("IdleChatter69"),
  Get_SS_Dialogue("IdleChatter70"),
  Get_SS_Dialogue("IdleChatter71"),
  Get_SS_Dialogue("IdleChatter72"),
  Get_SS_Dialogue("IdleChatter73"),
  Get_SS_Dialogue("IdleChatter74"),
  Get_SS_Dialogue("IdleChatter75"),
  Get_SS_Dialogue("IdleChatter76"),
  Get_SS_Dialogue("IdleChatter77"),
  Get_SS_Dialogue("IdleChatter78"),
  Get_SS_Dialogue("IdleChatter79"),
  Get_SS_Dialogue("IdleChatter80"),
  Get_SS_Dialogue("IdleChatter81"),
  Get_SS_Dialogue("IdleChatter82"),
  Get_SS_Dialogue("IdleChatter83"),
  Get_SS_Dialogue("IdleChatter84"),
  Get_SS_Dialogue("IdleChatter85"),
  Get_SS_Dialogue("IdleChatter86"),
  Get_SS_Dialogue("IdleChatter87"),
  Get_SS_Dialogue("IdleChatter88"),
  Get_SS_Dialogue("IdleChatter89"),
  Get_SS_Dialogue("IdleChatter90"),
  Get_SS_Dialogue("IdleChatter91"),
  Get_SS_Dialogue("IdleChatter92"),
  Get_SS_Dialogue("IdleChatter93"),
  Get_SS_Dialogue("IdleChatter94"),
  Get_SS_Dialogue("IdleChatter95"),
  Get_SS_Dialogue("IdleChatter96"),
  Get_SS_Dialogue("IdleChatter97"),
  Get_SS_Dialogue("IdleChatter98"),
  Get_SS_Dialogue("IdleChatter99"),
  Get_SS_Dialogue("IdleChatter100"),
  Get_SS_Dialogue("IdleChatter101"),
  Get_SS_Dialogue("IdleChatter102"),
  Get_SS_Dialogue("IdleChatter103"),
  Get_SS_Dialogue("IdleChatter104"),
  Get_SS_Dialogue("IdleChatter105"),
  Get_SS_Dialogue("IdleChatter106"),
  Get_SS_Dialogue("IdleChatter107"),
  Get_SS_Dialogue("IdleChatter108"),
  Get_SS_Dialogue("IdleChatter109"),
  Get_SS_Dialogue("IdleChatter110"),
  Get_SS_Dialogue("IdleChatter111"),
  Get_SS_Dialogue("IdleChatter112"),
  Get_SS_Dialogue("IdleChatter113"),
  Get_SS_Dialogue("IdleChatter114"),
  Get_SS_Dialogue("IdleChatter115"),
  Get_SS_Dialogue("IdleChatter116"),
  Get_SS_Dialogue("IdleChatter117"),
  Get_SS_Dialogue("IdleChatter118"),
  Get_SS_Dialogue("IdleChatter119"),
  Get_SS_Dialogue("IdleChatter120"),
  Get_SS_Dialogue("IdleChatter121"),
  Get_SS_Dialogue("IdleChatter122"),
  Get_SS_Dialogue("IdleChatter123"),
  Get_SS_Dialogue("IdleChatter124"),
  Get_SS_Dialogue("IdleChatter125"),
  Get_SS_Dialogue("IdleChatter126"),
  Get_SS_Dialogue("IdleChatter127"),
  Get_SS_Dialogue("IdleChatter128"),
  Get_SS_Dialogue("IdleChatter129"),
  Get_SS_Dialogue("IdleChatter130"),
  Get_SS_Dialogue("IdleChatter131"),
  Get_SS_Dialogue("IdleChatter132"),
  Get_SS_Dialogue("IdleChatter133"),
  Get_SS_Dialogue("IdleChatter134"),
  Get_SS_Dialogue("IdleChatter135"),
  Get_SS_Dialogue("IdleChatter136"),
  Get_SS_Dialogue("IdleChatter137"),
  Get_SS_Dialogue("IdleChatter138"),
  Get_SS_Dialogue("IdleChatter139"),
  Get_SS_Dialogue("IdleChatter140"),
};


SurvivorSpeechTable["PreZombieChatter"] = {
  Get_SS_Dialogue("PreZombieChatter1"),
  Get_SS_Dialogue("PreZombieChatter2"),
  Get_SS_Dialogue("PreZombieChatter3"),
  Get_SS_Dialogue("PreZombieChatter4"),
  Get_SS_Dialogue("PreZombieChatter5"),
  Get_SS_Dialogue("PreZombieChatter6"),
  Get_SS_Dialogue("PreZombieChatter7"),
  Get_SS_Dialogue("PreZombieChatter8"),
  Get_SS_Dialogue("PreZombieChatter9"),
  Get_SS_Dialogue("PreZombieChatter10"),
  Get_SS_Dialogue("PreZombieChatter11"),
  Get_SS_Dialogue("PreZombieChatter12"),
  Get_SS_Dialogue("PreZombieChatter13"),
  Get_SS_Dialogue("PreZombieChatter14"),
};


SurvivorSpeechTable["Hurt"] = {
  Get_SS_Dialogue("Hurt1"),
  Get_SS_Dialogue("Hurt2"),
  Get_SS_Dialogue("Hurt3"),
  Get_SS_Dialogue("Hurt4"),
  Get_SS_Dialogue("Hurt5"),
  Get_SS_Dialogue("Hurt6"),
  Get_SS_Dialogue("Hurt7"),
  Get_SS_Dialogue("Hurt8"),
  Get_SS_Dialogue("Hurt9"),
  Get_SS_Dialogue("Hurt10"),
  Get_SS_Dialogue("Hurt11"),
  Get_SS_Dialogue("Hurt12"),
  Get_SS_Dialogue("Hurt13"),
  Get_SS_Dialogue("Hurt14"),
  Get_SS_Dialogue("Hurt15"),
  Get_SS_Dialogue("Hurt16"),
  Get_SS_Dialogue("Hurt17"),
  Get_SS_Dialogue("Hurt18"),
};


SurvivorSpeechTable["Injured"] = {
  Get_SS_Dialogue("Injured1"),
  Get_SS_Dialogue("Injured2"),
  Get_SS_Dialogue("Injured3"),
  Get_SS_Dialogue("Injured4"),
  Get_SS_Dialogue("Injured5"),
  Get_SS_Dialogue("Injured6"),
  Get_SS_Dialogue("Injured7"),
  Get_SS_Dialogue("Injured8"),
  Get_SS_Dialogue("Injured9"),
  Get_SS_Dialogue("Injured10"),
  Get_SS_Dialogue("Injured11"),
  Get_SS_Dialogue("Injured12"),
  Get_SS_Dialogue("Injured13"),
  Get_SS_Dialogue("Injured14"),
  Get_SS_Dialogue("Injured15"),
  Get_SS_Dialogue("Injured16"),
  Get_SS_Dialogue("Injured17"),
  Get_SS_Dialogue("Injured18"),
  Get_SS_Dialogue("Injured19"),
  Get_SS_Dialogue("Injured20"),
};



SurvivorSpeechTable["BadInjured"] = {
  Get_SS_Dialogue("BadInjured1"),
  Get_SS_Dialogue("BadInjured2"),
  Get_SS_Dialogue("BadInjured3"),
  Get_SS_Dialogue("BadInjured4"),
  Get_SS_Dialogue("BadInjured5"),
  Get_SS_Dialogue("BadInjured6"),
  Get_SS_Dialogue("BadInjured7"),
  Get_SS_Dialogue("BadInjured8"),
  Get_SS_Dialogue("BadInjured9"),
  Get_SS_Dialogue("BadInjured10"),
  Get_SS_Dialogue("BadInjured11"),
  Get_SS_Dialogue("BadInjured12"),
  Get_SS_Dialogue("BadInjured13"),
  Get_SS_Dialogue("BadInjured14"),
  Get_SS_Dialogue("BadInjured15"),
  Get_SS_Dialogue("BadInjured16"),
  Get_SS_Dialogue("BadInjured17"),
};


SurvivorSpeechTable["SeriousInjured"] = {
  Get_SS_Dialogue("SeriousInjured1"),
  Get_SS_Dialogue("SeriousInjured2"),
  Get_SS_Dialogue("SeriousInjured3"),
  Get_SS_Dialogue("SeriousInjured4"),
  Get_SS_Dialogue("SeriousInjured5"),
  Get_SS_Dialogue("SeriousInjured6"),
  Get_SS_Dialogue("SeriousInjured7"),
  Get_SS_Dialogue("SeriousInjured8"),
  Get_SS_Dialogue("SeriousInjured9"),
  Get_SS_Dialogue("SeriousInjured10"),
  Get_SS_Dialogue("SeriousInjured11"),
  Get_SS_Dialogue("SeriousInjured12"),
  Get_SS_Dialogue("SeriousInjured13"),
  Get_SS_Dialogue("SeriousInjured14"),
  Get_SS_Dialogue("SeriousInjured15"),
  Get_SS_Dialogue("SeriousInjured16"),
  Get_SS_Dialogue("SeriousInjured17"),
  Get_SS_Dialogue("SeriousInjured18"),
  Get_SS_Dialogue("SeriousInjured19"),
  Get_SS_Dialogue("SeriousInjured20"),
  Get_SS_Dialogue("SeriousInjured21"),
  Get_SS_Dialogue("SeriousInjured22"),
  Get_SS_Dialogue("SeriousInjured23"),
};


SurvivorSpeechTable["FatalInjured"] = {
  Get_SS_Dialogue("FatalInjured1"),
  Get_SS_Dialogue("FatalInjured2"),
  Get_SS_Dialogue("FatalInjured3"),
  Get_SS_Dialogue("FatalInjured4"),
  Get_SS_Dialogue("FatalInjured5"),
  Get_SS_Dialogue("FatalInjured6"),
  Get_SS_Dialogue("FatalInjured7"),
  Get_SS_Dialogue("FatalInjured8"),
  Get_SS_Dialogue("FatalInjured9"),
  Get_SS_Dialogue("FatalInjured10"),
  Get_SS_Dialogue("FatalInjured11"),
  Get_SS_Dialogue("FatalInjured12"),
  Get_SS_Dialogue("FatalInjured13"),
  Get_SS_Dialogue("FatalInjured14"),
  Get_SS_Dialogue("FatalInjured15"),
  Get_SS_Dialogue("FatalInjured16"),
  Get_SS_Dialogue("FatalInjured17"),
};


SurvivorSpeechTable["FinalWords"] = {
  Get_SS_Dialogue("FinalWords1"),
  Get_SS_Dialogue("FinalWords2"),
  Get_SS_Dialogue("FinalWords3"),
  Get_SS_Dialogue("FinalWords4"),
  Get_SS_Dialogue("FinalWords5"),
  Get_SS_Dialogue("FinalWords6"),
  Get_SS_Dialogue("FinalWords7"),
  Get_SS_Dialogue("FinalWords8"),
  Get_SS_Dialogue("FinalWords9"),
  Get_SS_Dialogue("FinalWords10"),
  Get_SS_Dialogue("FinalWords11"),
  Get_SS_Dialogue("FinalWords12"),
  Get_SS_Dialogue("FinalWords13"),
  Get_SS_Dialogue("FinalWords14"),
  Get_SS_Dialogue("FinalWords15"),
  Get_SS_Dialogue("FinalWords16"),
  Get_SS_Dialogue("FinalWords17"),
  Get_SS_Dialogue("FinalWords18"),
  Get_SS_Dialogue("FinalWords19"),
  Get_SS_Dialogue("FinalWords20"),
  Get_SS_Dialogue("FinalWords21"),
  Get_SS_Dialogue("FinalWords22"),
  Get_SS_Dialogue("FinalWords23"),
  Get_SS_Dialogue("FinalWords24"),
  Get_SS_Dialogue("FinalWords25"),
  Get_SS_Dialogue("FinalWords26"),
  Get_SS_Dialogue("FinalWords27"),
  Get_SS_Dialogue("FinalWords28"),
  Get_SS_Dialogue("FinalWords29"),
  Get_SS_Dialogue("FinalWords30"),
  Get_SS_Dialogue("FinalWords31"),
};



SurvivorSpeechTable["NameText"] = {
  Get_SS_Dialogue("NameText1"),
  Get_SS_Dialogue("NameText2"),
  Get_SS_Dialogue("NameText3"),
  Get_SS_Dialogue("NameText4"),
  Get_SS_Dialogue("NameText5"),
  Get_SS_Dialogue("NameText6"),
  Get_SS_Dialogue("NameText7"),
  Get_SS_Dialogue("NameText8"),
  Get_SS_Dialogue("NameText9"),
};


SurvivorSpeechTable["Greetings"] = {
  Get_SS_Dialogue("Greetings1"),
  Get_SS_Dialogue("Greetings2"),
  Get_SS_Dialogue("Greetings3"),
  Get_SS_Dialogue("Greetings4"),
  Get_SS_Dialogue("Greetings5"),
  Get_SS_Dialogue("Greetings6"),
  Get_SS_Dialogue("Greetings7"),
  Get_SS_Dialogue("Greetings8"),
  Get_SS_Dialogue("Greetings9"),
  Get_SS_Dialogue("Greetings10"),
  Get_SS_Dialogue("Greetings11"),
  Get_SS_Dialogue("Greetings12"),
  Get_SS_Dialogue("Greetings13"),
  Get_SS_Dialogue("Greetings14"),
  Get_SS_Dialogue("Greetings15"),
  Get_SS_Dialogue("Greetings16"),
  Get_SS_Dialogue("Greetings17"),
  Get_SS_Dialogue("Greetings18"),
  Get_SS_Dialogue("Greetings19"),
  Get_SS_Dialogue("Greetings20"),
  Get_SS_Dialogue("Greetings21"),
  Get_SS_Dialogue("Greetings22"),
  Get_SS_Dialogue("Greetings23"),
  Get_SS_Dialogue("Greetings24"),
  Get_SS_Dialogue("Greetings25"),
  Get_SS_Dialogue("Greetings26"),
  Get_SS_Dialogue("Greetings27"),
  Get_SS_Dialogue("Greetings28"),
  Get_SS_Dialogue("Greetings29"),
  Get_SS_Dialogue("Greetings30"),
  Get_SS_Dialogue("Greetings31"),
  Get_SS_Dialogue("Greetings32"),
  Get_SS_Dialogue("Greetings33"),
  Get_SS_Dialogue("Greetings34"),
  Get_SS_Dialogue("Greetings35"),
  Get_SS_Dialogue("Greetings36"),
  Get_SS_Dialogue("Greetings37"),
  Get_SS_Dialogue("Greetings38"),
  Get_SS_Dialogue("Greetings39"),
  Get_SS_Dialogue("Greetings40"),
  Get_SS_Dialogue("Greetings41"),
  Get_SS_Dialogue("Greetings42"),
  Get_SS_Dialogue("Greetings43"),
  Get_SS_Dialogue("Greetings44"),
  Get_SS_Dialogue("Greetings45"),
  Get_SS_Dialogue("Greetings46"),
};


SurvivorSpeechTable["WantToHide"] = {
  Get_SS_Dialogue("WantToHide1"),
  Get_SS_Dialogue("WantToHide2"),
  Get_SS_Dialogue("WantToHide3"),
  Get_SS_Dialogue("WantToHide4"),
  Get_SS_Dialogue("WantToHide5"),
  Get_SS_Dialogue("WantToHide6"),
  Get_SS_Dialogue("WantToHide7"),
  Get_SS_Dialogue("WantToHide8"),
  Get_SS_Dialogue("WantToHide9"),
  Get_SS_Dialogue("WantToHide10"),
  Get_SS_Dialogue("WantToHide11"),
  Get_SS_Dialogue("WantToHide12"),
  Get_SS_Dialogue("WantToHide13"),
  Get_SS_Dialogue("WantToHide14"),
  Get_SS_Dialogue("WantToHide15"),
  Get_SS_Dialogue("WantToHide16"),
  Get_SS_Dialogue("WantToHide17"),
  Get_SS_Dialogue("WantToHide18"),
  Get_SS_Dialogue("WantToHide19"),
  Get_SS_Dialogue("WantToHide20"),
  Get_SS_Dialogue("WantToHide21"),
  Get_SS_Dialogue("WantToHide22"),
  Get_SS_Dialogue("WantToHide23"),
};



SurvivorSpeechTable["FoundHidingPlace"] = {
  Get_SS_Dialogue("FoundHidingPlace1"),
  Get_SS_Dialogue("FoundHidingPlace2"),
  Get_SS_Dialogue("FoundHidingPlace3"),
  Get_SS_Dialogue("FoundHidingPlace4"),
  Get_SS_Dialogue("FoundHidingPlace5"),
  Get_SS_Dialogue("FoundHidingPlace6"),
  Get_SS_Dialogue("FoundHidingPlace7"),
  Get_SS_Dialogue("FoundHidingPlace8"),
  Get_SS_Dialogue("FoundHidingPlace9"),
  Get_SS_Dialogue("FoundHidingPlace10"),
  Get_SS_Dialogue("FoundHidingPlace11"),
  Get_SS_Dialogue("FoundHidingPlace12"),
  Get_SS_Dialogue("FoundHidingPlace13"),
  Get_SS_Dialogue("FoundHidingPlace14"),
  Get_SS_Dialogue("FoundHidingPlace15"),
  Get_SS_Dialogue("FoundHidingPlace16"),
  Get_SS_Dialogue("FoundHidingPlace17"),
  Get_SS_Dialogue("FoundHidingPlace18"),
  Get_SS_Dialogue("FoundHidingPlace19"),
  Get_SS_Dialogue("FoundHidingPlace20"),
  Get_SS_Dialogue("FoundHidingPlace21"),
  Get_SS_Dialogue("FoundHidingPlace22"),
  Get_SS_Dialogue("FoundHidingPlace23"),
  Get_SS_Dialogue("FoundHidingPlace24"),
  Get_SS_Dialogue("FoundHidingPlace25"),
  Get_SS_Dialogue("FoundHidingPlace26"),
  Get_SS_Dialogue("FoundHidingPlace27"),
  Get_SS_Dialogue("FoundHidingPlace28"),
  Get_SS_Dialogue("FoundHidingPlace29"),
  Get_SS_Dialogue("FoundHidingPlace30"),
  Get_SS_Dialogue("FoundHidingPlace31"),
  Get_SS_Dialogue("FoundHidingPlace32"),
  Get_SS_Dialogue("FoundHidingPlace33"),
  Get_SS_Dialogue("FoundHidingPlace34"),
  Get_SS_Dialogue("FoundHidingPlace35"),
  Get_SS_Dialogue("FoundHidingPlace36"),
  Get_SS_Dialogue("FoundHidingPlace37"),
  Get_SS_Dialogue("FoundHidingPlace38"),
  Get_SS_Dialogue("FoundHidingPlace39"),
  Get_SS_Dialogue("FoundHidingPlace40"),
  Get_SS_Dialogue("FoundHidingPlace41"),
};


SurvivorSpeechTable["NoWhereToHide"] = {
  Get_SS_Dialogue("NoWhereToHide1"),
  Get_SS_Dialogue("NoWhereToHide2"),
  Get_SS_Dialogue("NoWhereToHide3"),
  Get_SS_Dialogue("NoWhereToHide4"),
  Get_SS_Dialogue("NoWhereToHide5"),
  Get_SS_Dialogue("NoWhereToHide6"),
  Get_SS_Dialogue("NoWhereToHide7"),
  Get_SS_Dialogue("NoWhereToHide8"),
  Get_SS_Dialogue("NoWhereToHide9"),
  Get_SS_Dialogue("NoWhereToHide10"),
  Get_SS_Dialogue("NoWhereToHide11"),
  Get_SS_Dialogue("NoWhereToHide12"),
  Get_SS_Dialogue("NoWhereToHide13"),
  Get_SS_Dialogue("NoWhereToHide14"),
  Get_SS_Dialogue("NoWhereToHide15"),
  Get_SS_Dialogue("NoWhereToHide16"),
  Get_SS_Dialogue("NoWhereToHide17"),
  Get_SS_Dialogue("NoWhereToHide18"),
  Get_SS_Dialogue("NoWhereToHide19"),
  Get_SS_Dialogue("NoWhereToHide20"),
  Get_SS_Dialogue("NoWhereToHide21"),
  Get_SS_Dialogue("NoWhereToHide22"),
  Get_SS_Dialogue("NoWhereToHide23"),
};


SurvivorSpeechTable["Panic"] = {
  Get_SS_Dialogue("Panic1"),
  Get_SS_Dialogue("Panic2"),
  Get_SS_Dialogue("Panic3"),
  Get_SS_Dialogue("Panic4"),
  Get_SS_Dialogue("Panic5"),
  Get_SS_Dialogue("Panic6"),
  Get_SS_Dialogue("Panic7"),
  Get_SS_Dialogue("Panic8"),
  Get_SS_Dialogue("Panic9"),
  Get_SS_Dialogue("Panic10"),
  Get_SS_Dialogue("Panic11"),
  Get_SS_Dialogue("Panic12"),
  Get_SS_Dialogue("Panic13"),
  Get_SS_Dialogue("Panic14"),
  Get_SS_Dialogue("Panic15"),
  Get_SS_Dialogue("Panic16"),
  Get_SS_Dialogue("Panic17"),
  Get_SS_Dialogue("Panic18"),
  Get_SS_Dialogue("Panic19"),
  Get_SS_Dialogue("Panic20"),
  Get_SS_Dialogue("Panic21"),
  Get_SS_Dialogue("Panic22"),
  Get_SS_Dialogue("Panic23"),
};


SurvivorSpeechTable["Scared"] = {
  Get_SS_Dialogue("Scared1"),
  Get_SS_Dialogue("Scared2"),
  Get_SS_Dialogue("Scared3"),
  Get_SS_Dialogue("Scared4"),
  Get_SS_Dialogue("Scared5"),
  Get_SS_Dialogue("Scared6"),
  Get_SS_Dialogue("Scared7"),
  Get_SS_Dialogue("Scared8"),
  Get_SS_Dialogue("Scared9"),
  Get_SS_Dialogue("Scared10"),
  Get_SS_Dialogue("Scared11"),
  Get_SS_Dialogue("Scared12"),
  Get_SS_Dialogue("Scared13"),
  Get_SS_Dialogue("Scared14"),
  Get_SS_Dialogue("Scared15"),
  Get_SS_Dialogue("Scared16"),
  Get_SS_Dialogue("Scared17"),
  Get_SS_Dialogue("Scared18"),
  Get_SS_Dialogue("Scared19"),
  Get_SS_Dialogue("Scared20"),
};


SurvivorSpeechTable["Screem"] = {
  Get_SS_Dialogue("Screem1"),
  Get_SS_Dialogue("Screem2"),
  Get_SS_Dialogue("Screem3"),
  Get_SS_Dialogue("Screem4"),
  Get_SS_Dialogue("Screem5"),
  Get_SS_Dialogue("Screem6"),
  Get_SS_Dialogue("Screem7"),
  Get_SS_Dialogue("Screem8"),
  Get_SS_Dialogue("Screem9"),
  Get_SS_Dialogue("Screem10"),
  Get_SS_Dialogue("Screem11"),
  Get_SS_Dialogue("Screem12"),
  Get_SS_Dialogue("Screem13"),
  Get_SS_Dialogue("Screem14"),
  Get_SS_Dialogue("Screem15"),
  Get_SS_Dialogue("Screem16"),
  Get_SS_Dialogue("Screem17"),
  Get_SS_Dialogue("Screem18"),
  Get_SS_Dialogue("Screem19"),
  Get_SS_Dialogue("Screem20"),
  Get_SS_Dialogue("Screem21"),
  Get_SS_Dialogue("Screem22"),
  Get_SS_Dialogue("Screem23"),
};



SurvivorSpeechTable["Attack"] = {
  Get_SS_Dialogue("Attack1"),
  Get_SS_Dialogue("Attack2"),
  Get_SS_Dialogue("Attack3"),
  Get_SS_Dialogue("Attack4"),
  Get_SS_Dialogue("Attack5"),
  Get_SS_Dialogue("Attack6"),
  Get_SS_Dialogue("Attack7"),
  Get_SS_Dialogue("Attack8"),
  Get_SS_Dialogue("Attack9"),
  Get_SS_Dialogue("Attack10"),
  Get_SS_Dialogue("Attack11"),
  Get_SS_Dialogue("Attack12"),
  Get_SS_Dialogue("Attack13"),
  Get_SS_Dialogue("Attack14"),
  Get_SS_Dialogue("Attack15"),
  Get_SS_Dialogue("Attack16"),
  Get_SS_Dialogue("Attack17"),
  Get_SS_Dialogue("Attack18"),
  Get_SS_Dialogue("Attack19"),
  Get_SS_Dialogue("Attack20"),
  Get_SS_Dialogue("Attack21"),
  Get_SS_Dialogue("Attack22"),
  Get_SS_Dialogue("Attack23"),
  Get_SS_Dialogue("Attack24"),
  Get_SS_Dialogue("Attack25"),
  Get_SS_Dialogue("Attack26"),
  Get_SS_Dialogue("Attack27"),
  Get_SS_Dialogue("Attack28"),
  Get_SS_Dialogue("Attack29"),
  Get_SS_Dialogue("Attack30"),
  Get_SS_Dialogue("Attack31"),
  Get_SS_Dialogue("Attack32"),
  Get_SS_Dialogue("Attack33"),
  Get_SS_Dialogue("Attack34"),
  Get_SS_Dialogue("Attack35"),
  Get_SS_Dialogue("Attack36"),
  Get_SS_Dialogue("Attack37"),
  Get_SS_Dialogue("Attack38"),
};


SurvivorSpeechTable["AttackS"] = {
  Get_SS_Dialogue("AttackS1"),
  Get_SS_Dialogue("AttackS2"),
  Get_SS_Dialogue("AttackS3"),
  Get_SS_Dialogue("AttackS4"),
  Get_SS_Dialogue("AttackS5"),
  Get_SS_Dialogue("AttackS6"),
  Get_SS_Dialogue("AttackS7"),
  Get_SS_Dialogue("AttackS8"),
  Get_SS_Dialogue("AttackS9"),
  Get_SS_Dialogue("AttackS10"),
  Get_SS_Dialogue("AttackS11"),
  Get_SS_Dialogue("AttackS12"),
  Get_SS_Dialogue("AttackS13"),
  Get_SS_Dialogue("AttackS14"),
  Get_SS_Dialogue("AttackS15"),
  Get_SS_Dialogue("AttackS16"),
  Get_SS_Dialogue("AttackS17"),
  Get_SS_Dialogue("AttackS18"),
  Get_SS_Dialogue("AttackS19"),
  Get_SS_Dialogue("AttackS20"),
  Get_SS_Dialogue("AttackS21"),
  Get_SS_Dialogue("AttackS22"),
  Get_SS_Dialogue("AttackS23"),
  Get_SS_Dialogue("AttackS24"),
  Get_SS_Dialogue("AttackS25"),
  Get_SS_Dialogue("AttackS26"),
  Get_SS_Dialogue("AttackS27"),
  Get_SS_Dialogue("AttackS28"),
  Get_SS_Dialogue("AttackS29"),
};


SurvivorSpeechTable["Traitor"] = {
  Get_SS_Dialogue("Traitor1"),
  Get_SS_Dialogue("Traitor2"),
  Get_SS_Dialogue("Traitor3"),
  Get_SS_Dialogue("Traitor4"),
  Get_SS_Dialogue("Traitor5"),
  Get_SS_Dialogue("Traitor6"),
  Get_SS_Dialogue("Traitor7"),
  Get_SS_Dialogue("Traitor8"),
  Get_SS_Dialogue("Traitor9"),
  Get_SS_Dialogue("Traitor10"),
  Get_SS_Dialogue("Traitor11"),
  Get_SS_Dialogue("Traitor12"),
  Get_SS_Dialogue("Traitor13"),
  Get_SS_Dialogue("Traitor14"),
  Get_SS_Dialogue("Traitor15"),
  Get_SS_Dialogue("Traitor16"),
  Get_SS_Dialogue("Traitor17"),
  Get_SS_Dialogue("Traitor18"),
  Get_SS_Dialogue("Traitor19"),
  Get_SS_Dialogue("Traitor20"),
  Get_SS_Dialogue("Traitor21"),
  Get_SS_Dialogue("Traitor22"),
};


SurvivorSpeechTable["LookingForZombie"] = {
  Get_SS_Dialogue("LookingForZombie1"),
  Get_SS_Dialogue("LookingForZombie2"),
  Get_SS_Dialogue("LookingForZombie3"),
  Get_SS_Dialogue("LookingForZombie4"),
  Get_SS_Dialogue("LookingForZombie5"),
  Get_SS_Dialogue("LookingForZombie6"),
  Get_SS_Dialogue("LookingForZombie7"),
  Get_SS_Dialogue("LookingForZombie8"),
  Get_SS_Dialogue("LookingForZombie9"),
  Get_SS_Dialogue("LookingForZombie10"),
  Get_SS_Dialogue("LookingForZombie11"),
  Get_SS_Dialogue("LookingForZombie12"),
  Get_SS_Dialogue("LookingForZombie13"),
  Get_SS_Dialogue("LookingForZombie14"),
  Get_SS_Dialogue("LookingForZombie15"),
};


SurvivorSpeechTable["FoundSurvivor"] = {
  Get_SS_Dialogue("FoundSurvivor1"),
  Get_SS_Dialogue("FoundSurvivor2"),
  Get_SS_Dialogue("FoundSurvivor3"),
  Get_SS_Dialogue("FoundSurvivor4"),
  Get_SS_Dialogue("FoundSurvivor5"),
  Get_SS_Dialogue("FoundSurvivor6"),
  Get_SS_Dialogue("FoundSurvivor7"),
  Get_SS_Dialogue("FoundSurvivor8"),
  Get_SS_Dialogue("FoundSurvivor9"),
  Get_SS_Dialogue("FoundSurvivor10"),
  Get_SS_Dialogue("FoundSurvivor11"),
  Get_SS_Dialogue("FoundSurvivor12"),
  Get_SS_Dialogue("FoundSurvivor13"),
  Get_SS_Dialogue("FoundSurvivor14"),
  Get_SS_Dialogue("FoundSurvivor15"),
  Get_SS_Dialogue("FoundSurvivor16"),
  Get_SS_Dialogue("FoundSurvivor17"),
  Get_SS_Dialogue("FoundSurvivor18"),
  Get_SS_Dialogue("FoundSurvivor19"),
  Get_SS_Dialogue("FoundSurvivor20"),
  Get_SS_Dialogue("FoundSurvivor21"),
  Get_SS_Dialogue("FoundSurvivor22"),
  Get_SS_Dialogue("FoundSurvivor23"),
  Get_SS_Dialogue("FoundSurvivor24"),
  Get_SS_Dialogue("FoundSurvivor25"),
  Get_SS_Dialogue("FoundSurvivor26"),
  Get_SS_Dialogue("FoundSurvivor27"),
  Get_SS_Dialogue("FoundSurvivor28"),
  Get_SS_Dialogue("FoundSurvivor29"),
  Get_SS_Dialogue("FoundSurvivor30"),
  Get_SS_Dialogue("FoundSurvivor31"),
  Get_SS_Dialogue("FoundSurvivor32"),
  Get_SS_Dialogue("FoundSurvivor33"),
  Get_SS_Dialogue("FoundSurvivor34"),
};


SurvivorSpeechTable["FoundZombie"] = {
  Get_SS_Dialogue("FoundZombie1"),
  Get_SS_Dialogue("FoundZombie2"),
  Get_SS_Dialogue("FoundZombie3"),
  Get_SS_Dialogue("FoundZombie4"),
  Get_SS_Dialogue("FoundZombie5"),
  Get_SS_Dialogue("FoundZombie6"),
  Get_SS_Dialogue("FoundZombie7"),
  Get_SS_Dialogue("FoundZombie8"),
  Get_SS_Dialogue("FoundZombie9"),
  Get_SS_Dialogue("FoundZombie10"),
  Get_SS_Dialogue("FoundZombie11"),
  Get_SS_Dialogue("FoundZombie12"),
  Get_SS_Dialogue("FoundZombie13"),
  Get_SS_Dialogue("FoundZombie14"),
  Get_SS_Dialogue("FoundZombie15"),
  Get_SS_Dialogue("FoundZombie16"),
  Get_SS_Dialogue("FoundZombie17"),
  Get_SS_Dialogue("FoundZombie18"),
  Get_SS_Dialogue("FoundZombie19"),
};
