ReturnToBaseTask = {}
ReturnToBaseTask.__index = ReturnToBaseTask

local isLocalLoggingEnabled = false;

function ReturnToBaseTask:new(superSurvivor)
	CreateLogLine("ReturnToBase", isLocalLoggingEnabled, "function: ReturnToBaseTask:new() called");
	local o = {}
	setmetatable(o, self)
	self.__index = self

	o.parent = superSurvivor
	o.Name = "Return To Base"
	o.OnGoing = false
	o.GroupID = superSurvivor:getGroupID();

	if (not o.GroupID) then
		CreateLogLine("ReturnToBase", isLocalLoggingEnabled, tostring(o.Name) .. "no group id");
		return nil
	end
	o.Group = SSGM:GetGroupById(o.GroupID)
	o.BaseCoords = o.Group:getBaseCenterCoords()

	return o
end

function ReturnToBaseTask:isComplete()
	if not self:isValid() or 
		self.parent:isInBase() or 
		not self.BaseCoords or 
		not self.BaseCoords[1] or 
		not self.BaseCoords[2] or 
		not self.BaseCoords[3]
	then
		return true
	else
		return false
	end
end

function ReturnToBaseTask:isValid()
	if not self.parent:getGroupID() then
		return false
	else
		return true
	end
end

function ReturnToBaseTask:update()
	if not self:isValid() then return false end


	if self.parent:isInAction() == false then
		local baseSquare = getCell():getGridSquare(self.BaseCoords[1], self.BaseCoords[2], self.BaseCoords[3])
		if baseSquare then
			self.parent:walkTo(baseSquare)
		else
			local cs = self.parent:Get():getCurrentSquare()
			if not cs or 
				not cs:IsOnScreen() 
			then
				self.parent.player:setX(self.BaseCoords[1])
				self.parent.player:setY(self.BaseCoords[2])
				self.parent.player:setZ(self.BaseCoords[3])
			else
				self.parent:walkTowards(self.BaseCoords[1], self.BaseCoords[2], self.BaseCoords[3])
			end
		end
	end
end
